<?php
namespace PhpImap;
require 'vendor/autoload.php';

$folders = ['INBOX','[Gmail]/Spam'];

$mysenders = $_POST['mysenders'];
$hoststring = $_POST['hoststring'];
$email_address = $_POST['email_address'];
$email_password = $_POST['email_password'];
$last_time = $_POST['last_time'];

$status = true;
$data_array = [];
$message_id_array = [];
$error_array = [];

    try {
                    
        $mailbox = new Mailbox($hoststring, $email_address, $email_password, false);
        
        foreach($folders as $folder) {
            
            try{
               
            $mailbox->switchMailbox($folder);
            $mailsIds = $mailbox->searchMailboxFrom('SINCE "'.$last_time.'" UNSEEN',...$mysenders);
        
            if($mailsIds){
                
                $total_emails = count($mailsIds);
                

                if($total_emails>0){
                    
                    shuffle($mailsIds);

                    $i=0;
                    
                    foreach($mailsIds as $num) {
                        $i++;

                        $markAsSeen = true;
                        $mail = $mailbox->getMail($num, false);
                        $lable = $mail->mailboxFolder;
                        $head = $mailbox->getMailHeader($num);
                        $fromAddress = $head->fromAddress;
                        $subject = $head->subject;
                        $message_id = trim($mail->messageId);
                        
                        
                        
                        $rereplied = false;
                        if(strpos($subject, "Re:") !== false){
                            $rereplied = true;
                        }
                        
                        
                    
                        if($lable=="[Gmail]/Spam"){
                            if($rereplied==false){
                                $data_array[] = ['from_address' => $fromAddress, 'type' => 's_spam'];
                            }
                            
                            $mailbox->markMailAsRead($num);
                            $mailbox->moveMail($num,"INBOX");
                            $mailbox->markMailAsImportant($num);

                        }else{

                           if($rereplied==false){
                            $data_array[] = ['from_address' => $fromAddress, 'type' => 's_inbox'];
                           }
                           
                           $mailbox->markMailAsRead($num);
                           
                        }
                        
                        if($message_id!=""){
                            $message_id_array[] = $message_id;
                           
                        }
                        
                        

                    }

                    
                }
                
                
            }

            }catch (\ConnectionException $ex) {
                $error = $ex->getMessage();
                $error_array[] = $error;
         
            }catch (\Exception $ex) {
                $error = $ex->getMessage();
                $error_array[] = $error;
            }
        }
        
        
        $mailbox->disconnect();
        
        }catch (\ConnectionException $ex) {
            $error = $ex->getMessage();
            $error_array[] = $error;
           
        }catch (\Exception $ex) {
            $error = $ex->getMessage();
            $error_array[] = $error;
            
        }
                    
                    

$data = array('status'=>$status,'message_id_array'=>$message_id_array,"error_array"=>$error_array,"data_array"=>$data_array);
echo json_encode($data);exit();
?>