<?php
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;
require 'vendor/autoload.php';

$response = "ERROR";
$version = 4;

function rrmdir($dir) {
  if (is_dir($dir)) {
    $objects = scandir($dir);
    foreach ($objects as $object) {
      if ($object != "." && $object != "..") {
        if (filetype($dir."/".$object) == "dir") 
           rrmdir($dir."/".$object); 
        else unlink   ($dir."/".$object);
      }
    }
    reset($objects);
    rmdir($dir);
  }
 }

if(isset($_POST)){

    if(isset($_POST['test_connection'])){
      $hostname = gethostname();
      if (!extension_loaded('zip')) {
           echo json_encode(array("statusCode" => "error", "message" => "ZIP extension not installed","version"=>$version));
           exit();
            
      }
        
      if (!extension_loaded('xml')) {
            echo json_encode(array("statusCode" => "error", "message" => "XML extension not installed","version"=>$version));
            exit();
            
      }
      
      
      if( \filter_var( \ini_get('allow_url_fopen'), \FILTER_VALIDATE_BOOLEAN ) ) {
      
        if(file_exists("imap_response.php") && file_exists("reply_response.php") && file_exists("check_email_response.php")){
            echo json_encode(array("statusCode" => "success", "message" => "Connection OK","version"=>$version,"hostname"=>$hostname));
            exit();
        }else{
            
           echo json_encode(array("statusCode" => "error", "message" => "There something wrong!","version"=>$version));
           exit(); 
        }
          
      }else{
          
          echo json_encode(array("statusCode" => "error", "message" => "allow_url_fopen is disabled","version"=>$version));
          exit();
          
      }
    }

    else if(isset($_POST['update'])){

        if(isset($_POST['master'])){
            
            if (!extension_loaded('zip')) {
               echo json_encode(array("statusCode" => "error", "message" => "ZIP extension not installed","version"=>$version));
               exit();
                
            }
            
            if (!extension_loaded('xml')) {
                echo json_encode(array("statusCode" => "error", "message" => "XML extension not installed","version"=>$version));
                exit();
                
            }
            
            if( \filter_var( \ini_get('allow_url_fopen'), \FILTER_VALIDATE_BOOLEAN ) ) {
                    $hostname = gethostname();
                    rrmdir("vendor");
                    
                    $download_url = "https://listwizz.pro/dashboard/crons/vendor.zip";
                	$file = "vendor.zip";
                	$script = basename($_SERVER['PHP_SELF']);
                	
                	file_put_contents($file, fopen($download_url, 'r'));
                
                	$path = pathinfo(realpath($file), PATHINFO_DIRNAME);
                
                	$zip = new ZipArchive;
                	$res = $zip->open($file);
                
                	if ($res === TRUE) {
                	  $zip->extractTo($path);
                	  $zip->close();
                
                	  unlink($file);
                
                	} else {
                	  echo json_encode(array("statusCode" => "error", "message" => "Unable to unzip the file","version"=>$version));
                      exit();
                	}
                	
                	
                	
                	$curl = curl_init();
    
                    curl_setopt_array($curl, array(
                      CURLOPT_URL => 'https://listwizz.pro/dashboard/crons/master-api/index.txt',
                      CURLOPT_RETURNTRANSFER => true,
                      CURLOPT_ENCODING => '',
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 30,
                      CURLOPT_FOLLOWLOCATION => true,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => 'GET',
                      CURLOPT_HTTPHEADER => array(
                        'Cookie: HttpOnly'
                      ),
                    ));
                
                    $response = curl_exec($curl);
                
                    curl_close($curl);
                
                    file_put_contents("index.php",$response);
                    $txt = '<?php echo "OK";?>';
                    file_put_contents("unsubscribe.php",$txt);
                	
                	
                	
                	$curl2 = curl_init();
    
                    curl_setopt_array($curl2, array(
                      CURLOPT_URL => 'https://listwizz.pro/dashboard/crons/master-api/imap_response.txt',
                      CURLOPT_RETURNTRANSFER => true,
                      CURLOPT_ENCODING => '',
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 30,
                      CURLOPT_FOLLOWLOCATION => true,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => 'GET',
                      CURLOPT_HTTPHEADER => array(
                        'Cookie: HttpOnly'
                      ),
                    ));
                
                    $response2 = curl_exec($curl2);
                
                    curl_close($curl2);
                
                    file_put_contents("imap_response.php",$response2);
                    
                    
                    $curl3 = curl_init();
    
                    curl_setopt_array($curl3, array(
                      CURLOPT_URL => 'https://listwizz.pro/dashboard/crons/master-api/reply_response.txt',
                      CURLOPT_RETURNTRANSFER => true,
                      CURLOPT_ENCODING => '',
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 30,
                      CURLOPT_FOLLOWLOCATION => true,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => 'GET',
                      CURLOPT_HTTPHEADER => array(
                        'Cookie: HttpOnly'
                      ),
                    ));
                
                    $response3 = curl_exec($curl3);
                
                    curl_close($curl3);
                
                    file_put_contents("reply_response.php",$response3);
                    
                    
                    $curl4 = curl_init();
    
                    curl_setopt_array($curl4, array(
                      CURLOPT_URL => 'https://listwizz.pro/dashboard/crons/master-api/check_email_response.txt',
                      CURLOPT_RETURNTRANSFER => true,
                      CURLOPT_ENCODING => '',
                      CURLOPT_MAXREDIRS => 10,
                      CURLOPT_TIMEOUT => 30,
                      CURLOPT_FOLLOWLOCATION => true,
                      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                      CURLOPT_CUSTOMREQUEST => 'GET',
                      CURLOPT_HTTPHEADER => array(
                        'Cookie: HttpOnly'
                      ),
                    ));
                
                    $response4 = curl_exec($curl4);
                
                    curl_close($curl4);
                
                    file_put_contents("check_email_response.php",$response4);
                    
                    
                    
                    if(isset($_POST['version'])){
                        $version = $_POST['version'];
                    }
                    echo json_encode(array("statusCode" => "success", "message" => "Master API Updated Successfully","version"=>$version,"hostname"=>$hostname));
                    exit();
    
                	
                }else{
                   echo json_encode(array("statusCode" => "error", "message" => "allow_url_fopen is disabled","version"=>$version));
                   exit();
                }
        }else{
            
            $curl = curl_init();
    
            curl_setopt_array($curl, array(
              CURLOPT_URL => 'https://listwizz.pro/dashboard/crons/smtp-api/index.txt',
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => '',
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 30,
              CURLOPT_FOLLOWLOCATION => true,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => 'GET',
              CURLOPT_HTTPHEADER => array(
                'Cookie: HttpOnly'
              ),
            ));
        
            $response = curl_exec($curl);
        
            curl_close($curl);
        
            file_put_contents("index.php",$response);
            $txt = '<?php echo "OK";?>';
            file_put_contents("unsubscribe.php",$txt);
            
            if(isset($_POST['version'])){
                $version = $_POST['version'];
            }
            echo json_encode(array("statusCode" => "success", "message" => "Normal API Updated Successfully","version"=>$version));
            exit();
        }


    }else if(isset($_POST['email']) && isset($_POST['subject']) && isset($_POST['message']) && isset($_POST['s_server']) && isset($_POST['s_username'])
    && isset($_POST['s_password']) && isset($_POST['s_protocol']) && isset($_POST['s_port']) && isset($_POST['s_from']) && isset($_POST['s_from_name']) && isset($_POST['message_id'])){

        $s_server = $_POST['s_server'];
        $id = "<" . md5('HELLO'.(idate("U")-1000000000).uniqid()).'@'.$s_server.'>';
        $mail = new PHPMailer(true);
        
        $message_id = $_POST['message_id'];
        $body  = $_POST['message'];
        $plain = strip_tags($body);

        try {

            $mail->SMTPDebug = 0;
            $mail->isSMTP();
            $mail->Host       = $_POST['s_server'];
            $mail->SMTPAuth   = true;
            $mail->Username   = $_POST['s_username'];
            $mail->Password   = $_POST['s_password'];
            $mail->SMTPSecure = $_POST['s_protocol'];
            $mail->Port       = $_POST['s_port'];
            $mail->Hostname = $_POST['s_server'];
            $mail->XMailer = ' ';

            $mail->SMTPOptions = array(
           'ssl' => array(
                    'verify_peer' => false,
                    'verify_peer_name' => false,
                    'allow_self_signed' => true
                )
            );
            $mail->addCustomHeader('In-Reply-To', $message_id);
            $mail->addCustomHeader('References', $message_id);
            $mail->MessageID = $id;
            $mail->setFrom($_POST['s_from'], $_POST['s_from_name']);
            $mail->addReplyTo($_POST['s_from'], $_POST['s_from_name']);
            $mail->addAddress($_POST['email']);

            $mail->isHTML(true);
            $mail->Subject = $_POST['subject'];
            $mail->Body    = $body;
            $mail->AltBody    = $plain;

            $mail->send();

            $response = $id;
        }
        catch (Exception $e) {

            $response = "ERROR";
        }


    }

    else if(isset($_POST['email']) && isset($_POST['subject']) && isset($_POST['message']) && isset($_POST['s_server']) && isset($_POST['s_username'])
    && isset($_POST['s_password']) && isset($_POST['s_protocol']) && isset($_POST['s_port']) && isset($_POST['s_from']) && isset($_POST['s_from_name'])){

        $s_server = $_POST['s_server'];
        $id = "<" . md5('HELLO'.(idate("U")-1000000000).uniqid()).'@'.$s_server.'>';
        $mail = new PHPMailer(true);
        $code = substr(str_shuffle(str_repeat($x='0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', ceil(10/strlen($x)) )),1,10);
        $url = "https://".$s_server."/smtp-api/";
        
        $body  = $_POST['message'];
        $plain = strip_tags($body);
        try {

            $mail->SMTPDebug = 0;
            $mail->isSMTP();
            $mail->Host       = $_POST['s_server'];
            $mail->SMTPAuth   = true;
            $mail->Username   = $_POST['s_username'];
            $mail->Password   = $_POST['s_password'];
            $mail->SMTPSecure = $_POST['s_protocol'];
            $mail->Port       = $_POST['s_port'];
            $mail->Hostname = $_POST['s_server'];
            $mail->XMailer = ' ';
            $mail->AddCustomHeader("List-Unsubscribe:  <mailto:no-reply@".$s_server.">,<".$url."unsubscribe.php?id=".$code.">");

            $mail->SMTPOptions = array(
           'ssl' => array(
                    'verify_peer' => false,
                    'verify_peer_name' => false,
                    'allow_self_signed' => true
                )
            );
            $mail->MessageID = $id;
            $mail->setFrom($_POST['s_from'], $_POST['s_from_name']);
            $mail->addReplyTo($_POST['s_from'], $_POST['s_from_name']);
            $mail->addAddress($_POST['email']);

            $mail->isHTML(true);
            $mail->Subject = $_POST['subject'];
            $mail->Body    = $body;
            $mail->AltBody    = $plain;

            $mail->send();

            $response = $id;
        }
        catch (Exception $e) {

            $response = "ERROR";
        }


    }
}

echo $response;