<?php
require 'vendor/autoload.php';
use PhpImap\Mailbox;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;
error_reporting(E_ALL);
$folders = ['INBOX','[Gmail]/Spam'];


$hoststring = '{imap.gmail.com:993/imap/ssl/novalidate-cert}';
$pva_email = $_POST['pva_email'];
$app_password = $_POST['app_password'];
$get_sender_email = $_POST['get_sender_email'];
$r_message_id = $_POST['r_message_id'];
$p_rbody = $_POST['p_rbody'];
$get_sender_name = $_POST['get_sender_name'];
$mid = $_POST['mid'];
$r_subject = $_POST['r_subject'];



$status = true;
$sent_array = [];
$error_array = [];


    $mailbox = new Mailbox($hoststring, $pva_email, $app_password, false);


    try{
                           

        $mailsIds = $mailbox->searchMailbox('SUBJECT "'.$r_subject.'"', $get_sender_email);
        

        if($mailsIds){
            
            rsort($mailsIds);
            array_splice($mailsIds, 1);
            
            $total_emails = count($mailsIds);
            

            if($total_emails>0){

                $i=0;
                
                foreach($mailsIds as $num) {
                    $i++;
                    
                    $email = $mailbox->getMail(
                		$num, // ID of the email, you want to get
                		true // Do NOT mark emails as seen
                	);
                	
                	

                	$message_id = $email->messageId;
                	$subject = 'Re: '.$r_subject;
                	
                	$ts = strtotime($email->date);
                    $date = date("D, d F Y \\a\\t h:i A", $ts);
                	
                	if ($email->textHtml) {
            	        $old_body = $email->textHtml;
                        $old_body = \Soundasleep\Html2Text::convert($old_body);
                    
                    } else {
                        $old_body = $email->textPlain;
                    }
                	
                	
                    
                  
                	if($message_id==""){
                	    $message_id = $r_message_id;
                	}
                	
                	
                	$body = $p_rbody;
                	$body .="<br><br>";
                	$body .= "On ".$date." ".$get_sender_name.' &lt;<a href="mailto:'.$get_sender_email.'" target="_blank">'.$get_sender_email.'</a>&gt;'." wrote: <br>";
                	$body .='<blockquote>'.nl2br($old_body).'</blockquote>';
                	
                	
                	try {
                	    
                	    $mail = new PHPMailer(true);
                	    
                	    
                        $mail->SMTPDebug = 0;
                        $mail->isSMTP();
                        $mail->Host       = 'smtp.googlemail.com';
                        $mail->SMTPAuth   = true;
                        $mail->Username   = $pva_email;
                        $mail->Password   = $app_password;
                        $mail->SMTPSecure = 'tls';
                        $mail->Port       = 587;
                		$mail->XMailer = ' ';
                		$mail->MessageID = $mid;

                		$mail->addCustomHeader('In-Reply-To', $message_id);
                        $mail->addCustomHeader('References', $message_id);
                    
                        //Recipients
                        $mail->addReplyTo($pva_email);
                        $mail->setFrom($pva_email);
                        $mail->addAddress($get_sender_email,$get_sender_name);
                        
                        $mail->isHTML(true);
                        $mail->Subject = $subject;
                        $mail->Body    = $body;
                        
                        if (!$mail->send()) {
                            echo 'Mailer Error: ' . $mail->ErrorInfo;
                        } else {
                            
                            $sent_array[] = ['id' => $mid, 'subject' => $subject];
                          
                        }
                        
                        
                        
                    } 
                    catch (Exception $e) {
                        echo 'Mailer Error: ' . $mail->ErrorInfo;
                    }
    
                    
                    

                }

                
            }
            
            
        }

        }catch (\ConnectionException $ex) {
            $error = $ex->getMessage();
            $error_array[] = $error;
            
     
        }catch (\Exception $ex) {
           $error = $ex->getMessage();
           $error_array[] = $error;
                
        }
        
        $mailbox->disconnect();
                    
                    

$data = array('status'=>$status,'sent_array'=>$sent_array,"error_array"=>$error_array);
echo json_encode($data);exit();
?>